#include "extern.h"

#define FORMATO_ENT "Numero de variables de entrada = %d \
Numero de Generaciones de la Estrategia de Evolucion = %d \
Numero de padres en la EE. Mu = %d \
Numero de hijos en la EE. Landa = %d \
Longitud de la cadena de desviaciones estandar. N_sigma = %d \
Longitud de la cadena de angulos. N_alfa = %d \
Operador de recombinacion a aplicar en la cadena solucion. Omega_x = %d \
Operador de recombinacion a aplicar en la cadena de desviaciones. Omega_sigma = %d \
Operador de recombinacion a aplicar en la cadena de angulos. Omega_alfa = %d \
Numero de padres a considerar en la recombinacion de la cadena solucion. Delta_x = %d \
Numero de padres a considerar en la recombinacion de la cadena de desviaciones. Delta_sigma = %d \
Numero de padres a considerar en la recombinacion de la cadena de angulos. Delta_alfa = %d \
Semilla = %f"

#define FORMATO_SAL "Numero de variables de entrada = %d \n\
Numero de Generaciones de la Estrategia de Evolucion = %d \n\
Numero de padres en la EE. Mu = %d \n\
Numero de hijos en la EE. Landa = %d \n\
N_sigma = %d \n\
N_alfa = %d \n\
Omega_x = %d \n\
Omega_sigma = %d \n\
Omega_alfa = %d \n\
Delta_x = %d \n\
Delta_sigma = %d \n\
Delta_alfa = %d \n\
Semilla = %f \n"

#define VAR_ENT  &n_x, \
                 &n_gen_ee,&Mu,&Landa,&n_sigma,&n_alfa,&Omega_x,&Omega_sigma, \
                 &Omega_alfa,&Delta_x,&Delta_sigma,&Delta_alfa,&semilla

#define VAR_SAL  n_x, \
                 n_gen_ee,Mu,Landa,n_sigma,n_alfa,Omega_x,Omega_sigma, \
                 Omega_alfa,Delta_x,Delta_sigma,Delta_alfa,semilla

float Maximo(x, y)
float x, y;
{
if (x>y) return(x);
else     return(y);
}

void Input (int argc, char *argv[])

/* Funcion que efectua la lectura de los datos de entrada desde el fichero
   entradat */

{
 int i,j,k, NumFuncion;
 char fichero_ent[100], fichero_sal[100];
 double sqrt(), tau;

 /* Se procede a la lectura de los datos de entrada */
 sprintf (fichero_ent,"%s","entrada.dat");
 if ((fp = fopen(fichero_ent, "r")) == NULL)
  {
   printf ("No se puede abrir el fichero de entrada %s",fichero_ent);
   abort ();
   }
 fscanf (fp,FORMATO_ENT,VAR_ENT); 

 fclose (fp);

 Seed=(unsigned long) semilla;

 printf (FORMATO_SAL,VAR_SAL);

 MAX=5.12;   MIN=-5.12; eval = f_1;  
	

 /* Calculo de los valores necesarios para la Estrategia de Evolucion. Los
    valores Tau_0, Tau y Tau_1 se usan para mutar las desviaciones tipicas 
    sigma y nl y nm son los indices con los que se calcula el producto de
    las matrices para hallar el valor correlado con el que se muta X */

 n_total=n_x+n_sigma+n_alfa;
 Tau_0=1.0/sqrt (2.0*n_x);
 Tau=1.0/sqrt (2.0*sqrt ((double)n_x));
 Tau_1=1.0/sqrt((double)n_x);
 nl_alfa=n_x+1-n_sigma;
 nm_alfa=n_x-1;


 /* Reserva de memoria para la Estrategia de Evolucion (Mu,Landa) */

 Padres = (STRUCTURE *) calloc ((unsigned)Mu,sizeof(STRUCTURE));
 if (Padres == NULL)  {printf ("Error en Calloc 1");abort ();}

 for (i=0; i<Mu; i++)
     {
     Padres[i].Gene=(TipoCromosoma) calloc ((unsigned)n_total,sizeof(TipoGen));
     if (Padres[i].Gene==NULL) {printf("Error en Calloc 2");abort();}
     }

 Hijos = (STRUCTURE *) calloc ((unsigned)Landa,sizeof(STRUCTURE));
 if (Hijos == NULL) {printf ("Error en Calloc 3");abort ();}

 for (i=0; i<Landa; i++)
     {
     Hijos[i].Gene=(TipoCromosoma) calloc ((unsigned)n_total,sizeof(TipoGen));
     if (Hijos[i].Gene==NULL) {printf("Error en Calloc 4");abort();}
     }

 Best_guy.Gene=(TipoCromosoma) calloc ((unsigned)n_total,sizeof(TipoGen));
 if (Best_guy.Gene==NULL) {printf("Error en Calloc 5");abort();}

 /* Reserva de memoria para la estructura que almacena los indices de los
    individuos seleccionados para efectuar la recombinacion en la EE */

 indices_recombinacion=(int *) calloc ((unsigned)Maximo (Delta_x,
                               Maximo (Delta_sigma,Delta_alfa)),sizeof (int));

 if (indices_recombinacion==NULL)
    {
    printf("Error en Calloc 6");
    abort();
    }

 /* Reserva de memoria para la estructura que almacena los valores no
    correlados para hacer la mutacion de X en la EE */

 Z=(float *) calloc ((unsigned)n_x,sizeof (float));
 if (Z==NULL)
    {
    printf("Error en Calloc 7");
    abort();
    }
}
