#include "random.h"
#include <iostream>
#include <math.h>

using namespace std;

/**
 * @var Seed Semilla aleatoria
 */
static unsigned long m_Seed;

static int changed = 1;

/**
 * inicia el valor de la semilla
 */
void Random::setSeed(unsigned long seed) {
   m_Seed = seed;
   changed = 1;
}

#define M  714025
#define IA 1366
#define IC 150889


/**
 * Genera aleatoriamente un nmero entre 0 y 1
 *
 * @return Un nmero aleatorio entre 0 y 1
 */
double  Random::rand(void) {
//   m_Seed = (m_Seed * PRIME) & MASK;
//   return (m_Seed * SCALE);

 	int j;
 	static long ir[98],iy;// idum = 13171191;
	static long idum = m_Seed;
 	static int iff=0;
 
 	if (idum < 0 || iff == 0 || changed == 1) {
 		iff=1;
 		if ((idum=(IC-(idum)) % M) < 0) idum = -(idum);
 		for (j=1;j<=97;j++) {
 			idum=(IA*(idum)+IC) % M;
 			ir[j]=(idum);
 		}
 		idum=(IA*(idum)+IC) % M;
 		iy=(idum);
		changed = 0;
 	}
 	j=(int)(1 + 97.0*(iy)/M);  
 
 	if (j > 97 || j < 1)
 		throw new string("Failure in random number generator");
 
 	iy=ir[j];
 	idum=(IA*(idum)+IC) % M;
 	ir[j]=(idum);
	m_Seed = idum;
 
 	return (float) (iy)/M;
}

unsigned long  Random::getSeed(void) {
   return m_Seed;
}

const double PI=3.1415926;

double Random::normal(double desv) {
  double u1, u2;
  double result;
  
  do {
    u1=Random::rand();
  } while (u1 == 0);

  u2=Random::rand();
  result = desv * sqrt (-2*log(u1)) * sin (2*PI*u2);
  
  return result;
}
